> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nx1cloud.com/llms.txt
> Use this file to discover all available pages before exploring further.

# What can be ingested

> Source kinds, file formats and their options, database engines, filter
operators and SaaS connectors this backend supports.



## OpenAPI

````yaml get /api/ingest/sources
openapi: 3.1.0
info:
  title: Nx1 AI API
  description: |

    AI API for Nx1 Data Platform Management and Automated Data Tasks.

    Authentication is required via PSK in Authorization header.

    Default PSK is | [ask a friend] |
  version: 0.10.2
servers: []
security: []
paths:
  /api/ingest/sources:
    get:
      tags:
        - Ingest pipelines
      summary: What can be ingested
      description: |-
        Source kinds, file formats and their options, database engines, filter
        operators and SaaS connectors this backend supports.
      operationId: sources_api_ingest_sources_get
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/api__models__ingest_pipeline_models__SourcesResponse
        '400':
          description: Invalid request.
        '403':
          description: Not allowed.
        '404':
          description: No such pipeline (or file).
        '409':
          description: Conflicts with the pipeline's state.
        '502':
          description: Airflow or the source couldn't be reached.
      security:
        - OAuth2AuthorizationCodeBearer: []
        - APIKeyHeader: []
components:
  schemas:
    api__models__ingest_pipeline_models__SourcesResponse:
      properties:
        source_kinds:
          items:
            $ref: '#/components/schemas/SourceKindInfo'
          type: array
          title: Source Kinds
        file_formats:
          items:
            $ref: '#/components/schemas/FileFormatInfo'
          type: array
          title: File Formats
        database_engines:
          items:
            $ref: '#/components/schemas/DbEngineInfo'
          type: array
          title: Database Engines
        filter_ops:
          items:
            $ref: '#/components/schemas/api__models__ingest_pipeline_models__FilterOp'
          type: array
          title: Filter Ops
        saas_connectors:
          items:
            $ref: '#/components/schemas/SaasConnectorInfo'
          type: array
          title: Saas Connectors
      type: object
      required:
        - source_kinds
        - file_formats
        - database_engines
        - filter_ops
        - saas_connectors
      title: SourcesResponse
    SourceKindInfo:
      properties:
        kind:
          $ref: '#/components/schemas/api__models__ingest_pipeline_models__SourceKind'
        label:
          type: string
          title: Label
        preview:
          type: boolean
          title: Preview
      type: object
      required:
        - kind
        - label
        - preview
      title: SourceKindInfo
    FileFormatInfo:
      properties:
        format:
          $ref: '#/components/schemas/FileFormat'
        label:
          type: string
          title: Label
        options:
          additionalProperties: true
          type: object
          title: Options
        preview:
          type: boolean
          title: Preview
      type: object
      required:
        - format
        - label
        - preview
      title: FileFormatInfo
    DbEngineInfo:
      properties:
        engine:
          $ref: '#/components/schemas/DbEngine'
        label:
          type: string
          title: Label
        default_port:
          type: integer
          title: Default Port
        supported:
          type: boolean
          title: Supported
        note:
          anyOf:
            - type: string
            - type: 'null'
          title: Note
      type: object
      required:
        - engine
        - label
        - default_port
        - supported
      title: DbEngineInfo
    api__models__ingest_pipeline_models__FilterOp:
      type: string
      enum:
        - eq
        - ne
        - in
        - gt
        - gte
        - lt
        - lte
        - is_null
        - not_null
      title: FilterOp
    SaasConnectorInfo:
      properties:
        name:
          type: string
          title: Name
        display_name:
          type: string
          title: Display Name
        category:
          type: string
          title: Category
        description:
          type: string
          title: Description
        config_fields:
          items:
            additionalProperties: true
            type: object
          type: array
          title: Config Fields
      type: object
      required:
        - name
        - display_name
        - category
        - description
      title: SaasConnectorInfo
    api__models__ingest_pipeline_models__SourceKind:
      type: string
      enum:
        - file
        - database
        - lakehouse
        - saas
      title: SourceKind
    FileFormat:
      type: string
      enum:
        - csv
        - json
        - parquet
        - orc
        - xml
        - xlsx
      title: FileFormat
    DbEngine:
      type: string
      enum:
        - postgres
        - mysql
        - sqlserver
        - oracle
        - db2
        - mongodb
      title: DbEngine
  securitySchemes:
    OAuth2AuthorizationCodeBearer:
      type: oauth2
      flows:
        authorizationCode:
          scopes: {}
          authorizationUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/auth
          tokenUrl: >-
            https://sso-rapid.rapid.nx1cloud.com/realms/rapid/protocol/openid-connect/token
    APIKeyHeader:
      type: apiKey
      in: header
      name: Authorization-PSK

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.